package org.jeecg.modules.database.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.database.entity.CnasTest;
import org.jeecg.modules.database.service.ICnasTestService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.Arrays;

/**
 * @Description: cnas测试参数列表
 * @Author: jeecg-boot
 * @Date: 2024-10-23
 * @Version: V1.0
 */
@Tag(name = "cnas测试参数列表")
@RestController
@RequestMapping("/database/cnasTest")
@Slf4j
public class CnasTestController extends JeecgController<CnasTest, ICnasTestService> {
    @Autowired
    private ICnasTestService cnasTestService;

    /**
     * 分页列表查询
     *
     * @param cnasTest
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "cnas测试参数列表-分页列表查询")
    @Operation(summary = "cnas测试参数列表-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<CnasTest>> queryPageList(CnasTest cnasTest,
                                                 @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                 @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                 HttpServletRequest req) {
        QueryWrapper<CnasTest> queryWrapper = QueryGenerator.initQueryWrapper(cnasTest, req.getParameterMap());
        Page<CnasTest> page = new Page<CnasTest>(pageNo, pageSize);
        IPage<CnasTest> pageList = cnasTestService.page(page, queryWrapper);
        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param cnasTest
     * @return
     */
    @AutoLog(value = "cnas测试参数列表-添加")
    @Operation(summary = "cnas测试参数列表-添加")
    @RequiresPermissions("database:cnas_test:add")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody CnasTest cnasTest) {
        cnasTestService.save(cnasTest);
        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     *
     * @param cnasTest
     * @return
     */
    @AutoLog(value = "cnas测试参数列表-编辑")
    @Operation(summary = "cnas测试参数列表-编辑")
    @RequiresPermissions("database:cnas_test:edit")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody CnasTest cnasTest) {
        cnasTestService.updateById(cnasTest);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "cnas测试参数列表-通过id删除")
    @Operation(summary = "cnas测试参数列表-通过id删除")
    @RequiresPermissions("database:cnas_test:delete")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        cnasTestService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "cnas测试参数列表-批量删除")
    @Operation(summary = "cnas测试参数列表-批量删除")
    @RequiresPermissions("database:cnas_test:delete")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.cnasTestService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "cnas测试参数列表-通过id查询")
    @Operation(summary = "cnas测试参数列表-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<CnasTest> queryById(@RequestParam(name = "id", required = true) String id) {
        CnasTest cnasTest = cnasTestService.getById(id);
        if (cnasTest == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(cnasTest);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param cnasTest
     */

    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, CnasTest cnasTest) {
        return super.exportXls(request, cnasTest, CnasTest.class, "cnas测试参数列表");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("database:cnas_test:add")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, CnasTest.class);
    }

}
